package x.awt;

import java.awt.*;

public class DiscreteColorScale implements ColorScale
{
    Color[] colors;
    private Color defaultColor;
    
    public DiscreteColorScale(int numColors, Color defaultColor)
    {
        this.defaultColor=defaultColor;
        colors=new Color[numColors];
        for (int i=0; i<numColors; i++)
            colors[i]=defaultColor;
    }
    
    public void setColor(int index, Color c)
    {
        colors[index]=c;
    }
    
    public Color color(double x)
    {
        int index=(int)Math.round(x);
        if (index>=0 && index<colors.length)
            return colors[index];
        else
            return defaultColor;
    }
  
}