package x.awt;

import java.awt.*;
import java.awt.event.*;

/**
 *
 * A component which handles the housekeeping involved
 * in dragging around a Lens object.
 *
 */
public class LensPanel extends BufferPanel implements ActionListener
{
    private Lens lens;
	private Image backdropImage;
	private Graphics backdropGraphics;
	
    
    
    public LensPanel()
    {
        lens=new Lens();
        
        lens.addActionListener(this);
        addMouseListener(lens);
        addMouseMotionListener(lens);
    }
    
    public void setBounds(int x, int y, int w, int h)
    {
        lens.setMoveableRegion(0,0,w,h);
        if (backdropGraphics!=null)
            backdropGraphics.dispose();
        if (w>0 && h>0)
        {
            backdropImage=createImage(w,h);
            backdropGraphics=backdropImage.getGraphics();
            redrawBackdrop();
        }
        super.setBounds(x,y,w,h);
    }
    
    public void setLensBounds(int x, int y, int w, int h)
    {
        lens.setBounds(x,y,w,h);
        redraw();
    }
    
    public void actionPerformed(ActionEvent e)
    {
        if (e.getSource()==lens)
        {
            redraw();
            Rectangle r=lens.getBounds();
            lensMoved(r.x, r.y, r.width, r.height);
        }
    }
    
    protected void lensMoved(int x, int y, int w, int h)
    {
    }
    
    public void redrawBackdrop()
    {
        backdropGraphics.setColor(getBackground());
        backdropGraphics.fillRect(0,0,getSize().width, getSize().height);
        drawBackdrop(backdropGraphics);
        redraw();
    }
    
    protected void drawBackdrop(Graphics g)
    {
    }
    
    protected void drawOffscreen(Graphics g)
    {
        clearBuffer();
        if (backdropImage!=null)
            g.drawImage(backdropImage,0,0,null);
        lens.draw(g);
    }
}