package x.awt.image;

import java.awt.image.*;
import java.awt.*;

public class ShrinkImage 
{
    static int[] divide9=new int[9*256];
    static 
    {
        for (int i=0; i<divide9.length; i++)
            divide9[i]=i/9;
    }

    public static int averagePixels(int[] set) {
        int avg=0,r=0,g=0,b=0;
        int n=set.length;
        for (int i=0; i<n; i++) {
            int p=set[i];
            b+=p&255;
            g+=(p&(255<<8))>>8;
            r+=(p&(255<<16))>>16;
        }
        return  b/n | (g/n)<<8 | (r/n)<<16 | -1<<24;
    }

    public static MemoryImageSource by3(byte[] bigBytes, int bigWidth, int bigHeight, IndexColorModel model) 
    {
        int smallHeight=bigHeight/3;
        int smallWidth=bigWidth/3;
        if (smallHeight <= 0 || smallWidth <= 0) return null;

        byte[] smallPix = new byte[smallHeight*smallWidth];

        int i,j;

        int[] pixSet= new int[9];

        for (i=0; i<smallWidth; i++)
            for (j=0; j<smallHeight; j++) {

                int k,m,p=0;
                int b=i*3+smallWidth*9*j;

                int n=0;

                for (k=0; k<3; k++)
                    for (m=0; m<3; m++)
                        pixSet[n++]=bigBytes[b+k+smallWidth*3*m];
                        
                int zavg=0,zr=0,zg=0,zb=0;
                int zn=pixSet.length;
                for (int zq=0; zq<zn; zq++) {
                    int zp=pixSet[zq];
                    zb+=zp&255;
                    zg+=(zp&(255<<8))>>8;
                    zr+=(zp&(255<<16))>>16;
                }

                smallPix[i+smallWidth*j]=(byte)divide9[zb];

            }

        return new MemoryImageSource(smallWidth, smallHeight, model, 
                                     smallPix, 0, smallWidth);

    }



    public static MemoryImageSource by3(Image bigImage) {
        int bigHeight=bigImage.getHeight(null);
        int bigWidth=bigImage.getWidth(null);
        int smallHeight=bigHeight/3;
        int smallWidth=bigWidth/3;
        if (smallHeight <= 0 || smallWidth <= 0) return null;

        int[] bigPix = new int[bigHeight*bigWidth];
        int[] smallPix = new int[smallHeight*smallWidth];

        PixelGrabber bigGrab =
            new PixelGrabber(bigImage, 0,0, bigWidth,bigHeight,
                             bigPix, 0,bigWidth);
        try {bigGrab.grabPixels();}
        catch (InterruptedException ie) {}

        int i,j;

        int[] pixSet= new int[9];

        for (i=0; i<smallWidth; i++)
            for (j=0; j<smallHeight; j++) {

                int k,m,p=0;
                int b=i*3+smallWidth*9*j;

                int n=0;

                for (k=0; k<3; k++)
                    for (m=0; m<3; m++)
                        pixSet[n++]=bigPix[b+k+smallWidth*3*m];
                        
                int zavg=0,zr=0,zg=0,zb=0;
                int zn=pixSet.length;
                for (int zq=0; zq<zn; zq++) {
                    int zp=pixSet[zq];
                    zb+=zp&255;
                    zg+=(zp&(255<<8))>>8;
                    zr+=(zp&(255<<16))>>16;
                }

                smallPix[i+smallWidth*j]=divide9[zb] | 
                                         divide9[zg] <<8 | 
                                         divide9[zr] <<16 | -1<<24;

            }

        return new MemoryImageSource(smallWidth, smallHeight,
                                smallPix, 0, smallWidth);

    }


}
