package x.awt.test;

import x.awt.*;

import java.awt.*;
import java.awt.event.*;

/**
 *
 * Creates and tests the GradientColorScale object. If all works
 * correctly, you should see a red-yellow-green spectrum.
 *
 */
public class ColorScaleTest extends Frame
{
    public static void main(String[] args)
    {
        new ColorScaleTest().launch();
    }
    
    public void launch()
    {
        setBounds(100,100,400,400);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {System.exit(0);}
        });
        setVisible(true);
        setLayout(null);
        
    }
    
    public void paint(Graphics g)
    {
        int x;
        
        ColorScale c=new GradientColorScale(Color.red, Color.yellow, Color.green, 100, 300);
        for (x=0; x<400; x++)
        {
            g.setColor(c.color(x));
            g.drawLine(x,0,x,100);
        }
        
        DiscreteColorScale d=new DiscreteColorScale(10, Color.gray);
        d.setColor(0,Color.red);
        d.setColor(5, Color.green);
        d.setColor(9, Color.blue);
        
        for (x=0; x<400; x++)
        {
            g.setColor(d.color(x*.05));
            g.drawLine(x,110,x,200);
        }
    }
    
}
