package x.cluster;

public class EuclideanMST implements MST
{
    public Edge[] makeMST(float[][] points)
    {
        int n=points.length;
        int dimension=points[0].length;
        Edge[] tree=new Edge[n-1];
        boolean[] inTree=new boolean[n];
        int[] nearestNeighbor=new int[n];
        float[] nearestNeighborDistance=new float[n];
        int i;
        for (i=0; i<n; i++)
            nearestNeighborDistance[i]=Float.MAX_VALUE;
            
        int minIndex=0;
        float minDist=0;
        
        // Perform Prim's algorithm.
        for (i=0; i<n; i++)
        {
            int j;
            
            // Put nearest item in tree.
            inTree[minIndex]=true;
            if (i>0)
                tree[i-1]=new Edge(minIndex, nearestNeighbor[minIndex], minDist);
            float[] p=points[minIndex];
                
            // Update distances.
            minDist=Float.MAX_VALUE;
            int justAddedIndex=minIndex;
            for (j=0; j<n; j++)
            {
                if (!inTree[j])
                {
                    float d2=0;
                    float[] q=points[j];
                    float n2=nearestNeighborDistance[j];
                    int k;
                    
                    for (k=dimension-1; k>=0; k--)
                    {
                        if ((d2+=(p[k]-q[k])*(p[k]-q[k]))>n2)
                            break;
                    }
                    
                    
                    if (d2<n2)
                    {
                        nearestNeighbor[j]=justAddedIndex;
                        n2=(nearestNeighborDistance[j]=d2);
                    }
                    
                    if (n2<minDist)
                    {
                        minIndex=j;
                        minDist=n2;
                    }
                }
            }
            
        }
        return tree;
    }
}