package x.cluster;

import x.data.*;
import x.math.*;

import java.io.*;
import java.util.*;

/**
 *
 * Utility for creating a single-linkage clustering from
 * a given DataArray, and then printing the results to
 * System.out.
 *
 */
public class PrintCluster
{
    public static void main(String[] args)
    {
        if (args.length!=1)
        {
            System.err.println("usage: PrintCluster metafile");
            System.exit(0);
        }

        System.err.println("Performing single-linkage cluster from metafile: "+args[0]);
        System.err.println("also: NORMALIZING DATA TO UNIT LENGTH!!");
        try
        {
            
            MetaData m=new MetaData(new File(args[0]));
            System.err.println("Done reading meta file; now reading data file.");
            DataArray d=new DataArray(m);
            d.readFromFile(true);
            System.err.println("Done reading data file; now clustering.");
            int n=d.size();
            float[][] f=d.copyNumbers();
            for (int i=0; i<n; i++)
                Geometry.unit(f[i]);
            HierarchicalClusterAnalysis h=new SingleLinkageCluster(MetricType.Euclidean);
            ClusterNode c=h.makeClusterTree(f);
            ClusterFormat.write(c, d.getData(), System.out);
            System.err.println("Clustering complete.");
        }
        catch (Exception e)
        {
           e.printStackTrace(System.err);
        }
    }
}