package x.cluster.test;

import x.cluster.*;

import java.awt.*;
import java.util.*;

public class MSTTest extends x.awt.FrameApp
{
    static int SIZE=250;
    static int DIM=2;
    static int width;
    Edge[] tree;
    float[][] vertex;
    long totalTime;
    
    public static void main(String[] args)
    {
        try
        {
            SIZE=Integer.parseInt(args[0]);
            DIM=Integer.parseInt(args[1]);
            MSTTest m=new MSTTest();
            width=400;
            m.init();
            m.launch(100,100,400,400);
        }
        catch (Exception e)
        {
            e.printStackTrace(System.err);
            System.err.println("usage: ClusterTest size dim");
        }
    }
    
    public void init()
    {
        makeNew();
        setFont(new Font("Helvetica", Font.BOLD, 12));
    }
    
    public boolean mouseDown(Event e, int x, int y)
    {
        makeNew();
        repaint();
        return true;
    }
    
    public void paint(Graphics g)
    {
        int n=vertex.length;
        int i;
        int cx=size().width/2;
        
        // edges.
        g.setColor(Color.lightGray);
        for (i=0; i<tree.length; i++)
        {
            Edge e=tree[i];
            int x1=cx+(int)vertex[e.v1][0];
            int y1=cx+(int)vertex[e.v1][1];
            int x2=cx+(int)vertex[e.v2][0];
            int y2=cx+(int)vertex[e.v2][1];
            g.drawLine(x1,y1,x2,y2);
        }
        
        // vertices.
        g.setColor(Color.gray);
        for (i=0; i<n; i++)
        {
            int x=cx+(int)vertex[i][0];
            int y=cx+(int)vertex[i][1];
            g.fillRect(x-1,y-1,3,3);
        }
        
        // info.
        g.setColor(Color.black);
        g.drawString("vertices: "+SIZE, 10, 30);
        g.drawString("dimension: "+DIM, 10, 50);
        g.drawString("Total time: "+totalTime, 10, 70);
        
    }
    
    void makeNew()
    {
        Random r=new Random();
        int n=SIZE;
        vertex=new float[n][DIM];
        int w=width;
        for (int i=0; i<n; i++)
        {
            float f=Math.random()<.5 ? -w/4 : w/4;
            for (int j=0; j<DIM; j++)
                vertex[i][j]=(float)(f+w*.15*r.nextGaussian());
            //Geometry.unit(vertex[i]);
            //Geometry.mul(vertex[i], w/2);
        }
        long t=System.currentTimeMillis();
        tree=new EuclideanMST().makeMST(vertex);
        totalTime=System.currentTimeMillis()-t;
    }
    
    
}