package x.cluster.test;

import x.cluster.*;
import x.data.*;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class TestTree extends Frame
{
    ClusterNode root;
    
    public static void main(String[] args)
    {
        System.err.println("Cluster file test.");
        System.err.println("args[0] is meta file, args[1] is cluster file.");
        try
        {
            
            MetaData m=new MetaData(new File(args[0]));
            DataArray d=new DataArray(m);
            d.readFromFile(true);
            
            ClusterNode c=ClusterFormat.read(args[1], d.getData());
            System.out.println("data rows: "+d.size());
            System.out.println("cluster leaves: "+c.countLeaves());
            
            
            //ClusterNode c=fake(15);
            TestTree t=new TestTree(c);
            t.launch(50,50,800,600);
            
        }
        catch (Exception e)
        {
           e.printStackTrace(System.err);
        }
    }
    
    public void paint(Graphics g)
    {
        drawTree(g, root, 50, 700, 30, 2);
    }
    
    static ClusterNode fake(int depth)
    {
        ClusterNode c=new ClusterNode();
        if (depth!=0 && Math.random()>.1)
            c.setChildren(fake(depth-1), fake(depth-1));
        return c;
    }
    
    void drawTree(Graphics g, ClusterNode c, double x, double w, int y, int dy)
    {
        if (!c.hasChildren()) return;
        ClusterNode c1=c.getChild(0);
        ClusterNode c2=c.getChild(1);
        int n1=1+c1.countLeaves();
        int n2=1+c2.countLeaves();
        g.drawLine((int)(x+w/2), y, (int)(x+w/2), y+dy);
        g.drawLine((int)(x+((w*n1)/2)/(n1+n2)),y+dy, (int)(x+(w*n1+(w*n2)/2)/(n1+n2)),y+dy);
        drawTree(g, c1, x, (w*n1)/(n1+n2), y+dy, dy);
        drawTree(g, c2, x+(w*n1)/(n1+n2), (w*n2)/(n1+n2), y+dy, dy);
    }
    
    public TestTree(ClusterNode root)
    {
        this.root=root;
    }
    
    public void launch(int x, int y, int w, int h)
    {
        setBounds(x,y,w,h);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) 
            {
                System.exit(0);
            }
        });
        setVisible(true);
    }
    
}