package x.cluster.view;

import x.cluster.*;
import x.data.*;
import x.path.*;


import java.awt.*;
import java.awt.event.*;


public class ClusterMap extends Frame
{
    private OverviewAndDetail display;
    
    public static void main(String[] args)
    {
        if (args.length!=2)
        {
            System.err.println("usage: ClusterMap metafile clusterfile");
			System.err.println("...using defaults instead.");
            //return;
            args=new String[2];
			//args[0]="c:\\data\\bio\\eisen.meta";
			//args[1]="c:\\data\\bio\\eisen-orig.cluster";
			//args[0]="c:\\data\\bio\\whitehead\\test.meta";
			//args[1]="c:\\data\\bio\\whitehead\\test.gtr";
			args[0]="c:\\data\\bio\\whitehead\\lung.meta";
			args[1]="c:\\data\\bio\\whitehead\\lung.gtr";
        }
        
        try
        {
            ClusterMap c=new ClusterMap(args[0], args[1]);
            c.setBounds(50,50,900,500);
            c.setVisible(true);
            c.display.render();
        }
        catch (Exception e)
        {
            e.printStackTrace(System.err);
        }
    }
    
    
    private ClusterMap(String metaFile, String clusterFile) throws Exception
    {
        // Read data.
        DataArray data=new DataArray(metaFile);
        
        // Read clustering for this data.
        ClusterNode root=ClusterFormat.read(clusterFile, data.getData());
        
        // Make order.
        int[] order=root.makeDataIndexList();
        
        // Make 2D layout.
        //PathLayout path=new HilbertPath(data.size(), 400, 400);
		PathLayout path=new HCurve(data.size());
		//PathLayout path=new ReadingPath(data.size(),100,100);
        
        setBackground(Color.white);
        setLayout(new GridLayout(1,1));

        // Set up visualization panel.
        display=new OverviewAndDetail(data, root, order, path);
        add(display);

        // Set up window.
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {System.exit(0);}
        });
        
    }
    
}