package x.cluster.view;

import x.awt.*;
import x.data.*;
import java.awt.*;

class ClusterMapLabel implements MakeDataLabel
{
    static Font font=new Font("Helvetica", Font.PLAIN, 11);
    static Color bgcolor=new Color(0xeeeeee);
    
    public Drawing labelFor(DataRow row)
    {
        return new MapLabel(row);
    }

    class MapLabel implements Drawing
    {
        int pad=5, gh=50;
        int w,h;
        LongText text;
        DataRow row;
        
        
        MapLabel(DataRow row)
        {
            this.row=row;
            int n=row.getNumbers().length;
            w=Math.max(150, n+2*pad);
            text=new LongText(row.getText()[1], font, w);
            h=3*pad+gh+text.getSize().height;
        }
        
        public Dimension getSize()
        {
            return new Dimension(w,h);
        }
        
        public void draw(Graphics g, int x, int y)
        {
            Font f=g.getFont();
            g.setColor(bgcolor);
            g.fillRect(x,y,w,h);
            g.setColor(MapInfo.textColor);
            g.drawRect(x,y,w,h);
            g.setColor(Color.black);
            text.draw(g, x+pad, y+2*pad+gh);
            int n=row.getNumbers().length;
            int by=y+pad+gh/2;
            g.setColor(Color.lightGray);
            g.fillRect(x+pad,y+pad,n,gh);
            g.setColor(Color.darkGray);
            for (int i=0; i<n; i++)
            {
                int a=x+pad+i;
                double value=row.getNumbers()[i];
                //if (value==0)
                //{
                //    g.setColor(bgcolor);
                //    g.drawLine(a,y+pad,a,y+pad+gh);
                //}
                //else
                //{
                //    g.setColor(Color.darkGray);
                    int b=(int)(by+30*value);
                    g.drawLine(a,b,a,by);
                //}
            }
            g.setFont(f);
        }
    }
}
