package x.cluster.view;

import x.cluster.*;
import x.data.*;


import java.awt.*;
import java.awt.event.*;


public class ClusterScatterplot extends Frame
{
    static int startW=500, startH=500;
    ClusterBiplot plot;
    
    public static void main(String[] args)
    {
        if (args.length!=3)
        {
            System.err.println("usage: ClusterScatterplot metafile clusterfile1 clusterfile2");
            System.exit(0);
        }
        
        try
        {
            ClusterScatterplot c=new ClusterScatterplot(args[0], args[1], args[2]);
            c.launch(100,100,startW,startH);
            c.plot.start();
        }
        catch (Exception e)
        {
            e.printStackTrace(System.err);
        }
    }
    
    public void launch(int x, int y, int w, int h)
    {
        setBounds(x,y,w,h);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) 
            {
                plot.stop();
                System.exit(0);
            }
        });
        setVisible(true);
    }
    
    
    private ClusterScatterplot(String metaFile, String clusterFile1, String clusterFile2) throws Exception
    {
        // Read data.
        DataArray data=new DataArray(metaFile, true, Integer.MAX_VALUE);
        
        // Read clustering.
        ClusterNode root1=ClusterFormat.read(clusterFile1, data.getData());
        ClusterNode root2=ClusterFormat.read(clusterFile2, data.getData());
        
        // Create and add plotting component.
        plot=new ClusterBiplot(data, root1, root2);
        setLayout(new GridLayout(1,1));
        add(plot);
    }
    
}