package x.data;

import java.util.*;

public class WordFinder
{
    
    public static int match(DataArray data, int column, String target, boolean[] result)
    {
        DataRow[] row=data.getData();
        int n=row.length;
        if (n!=result.length)
            throw new IllegalArgumentException("Result length != data size: "+
                result.length+" != "+n);
                
        int matchesFound=0;
        for (int i=0; i<n; i++)
        {
            String s=row[i].getText()[column];
            int q=s.indexOf(target);
            result[i] = !(q==-1 || q>0 && s.charAt(q-1)!=' ');
            if (result[i])
                matchesFound++;
        }
        
        return matchesFound;
    }
    
    // dumb implementation; fix if this routine is used a lot.
    public static String[] getWords(DataArray data, int column)
    {
        
        Vector v=new Vector();
        Enumeration k=getWordFrequency(data, column).keys();
        while (k.hasMoreElements())
            v.addElement(k.nextElement());
        String[] s=new String[v.size()];
        v.copyInto(s);
        return s;
    }
    
    public static Hashtable getWordFrequency(DataArray data, int column)
    {
        DataRow[] row=data.getData();
        int n=row.length;
        Hashtable words=new Hashtable();

        for (int i=0; i<n; i++)
        {
            String s=row[i].getText()[column];
            StringTokenizer t=new StringTokenizer(s," \t,.;:\"'");
            while (t.hasMoreTokens())
            {
                String w=t.nextToken();
                Integer count=(Integer)words.get(w);
                int m= count==null ? 1 : 1+count.intValue();
                words.put(w, new Integer(m));
            }
        }
        return words;
    }
}