package x.data.seq;

import java.util.*;
import java.io.*;

/**
 * 
 * Sequence w/ID and index to a DataArray.
 *
 */
public class AnnotatedSequence
{
    private Sequence sequence;
    private String id;
    private String comments;
    private int dataIndex;
    private float value;
    
    
    public AnnotatedSequence(Sequence sequence, String id, String comments)
    {
        this.sequence=sequence;
        this.id=id;
        this.comments=comments;
    }
    
    public void setValue(float value)
    {
        this.value=value;
    }
    
    public float getValue()
    {
        return value;
    }
    
    /**
     *
     * Useful for maintaining a pointer to a row in a DataArray
     * or similar structure.
     *
     */
    public void setDataIndex(int dataIndex)
    {
        this.dataIndex=dataIndex;
    }
    
    public int getDataIndex()
    {
        return dataIndex;
    }
    
    public Sequence getSequence()
    {
        return sequence;
    }
    
    public String getID()
    {
        return id;
    }
    
    public String getComments()
    {
        return comments;
    }
    
    public int length()
    {
        return sequence.length();
    }
    
    public String toString()
    {
        return "AnnotatedSequence, length="+length()+"; "+id+"; "+comments;
    }
}