package x.data.seq;

public class AverageSequence
{
    private int numAveraged;
    private float[][] average=new float[4][];
    private int length;
    
    public AverageSequence(int length) 
    {
        this.length=length;
        makeArrays();
    }
    
    public AverageSequence() 
    {
    }
    
    private void makeArrays()
    {
        for (int i=0; i<average.length; i++)
            average[i]=new float[length];
    }
    
    public int length()
    {
        return length;
    }
    
    public float[] data(byte c)
    {
        return average[c];
    }
    
    public void add(Sequence s)
    {
        if (length==0)
        {
            length=s.length();
            makeArrays();
        }
        
        if (s.length()!=length)
            throw new IllegalArgumentException("sequence lengths not equal!");
            
        // weights for weighted average.
        float u=numAveraged/(float)(numAveraged+1);
        float v=1-u;
        int m=average.length;
        for (int i=0; i<length; i++)
        {
            byte c=s.data(i);

            for (int j=0; j<m; j++)
            {
                average[j][i]*=u;
                if (c==j)
                    average[j][i]+=v;
                
            }
        }
        
        numAveraged++;
    }
    
    public String toString()
    {
        return "Average of "+numAveraged+" sequences of length "+length;
    }
}