package x.data.seq;

import java.util.*;
import java.io.*;

/**
 * 
 * Open Reading Frame, Stanford format.
 *
 */
public class ORF
{
    /**
     *
     * Read from a sequence with comments in the same form
     * as the Stanford Yeast database.
     *
     */
    public static AnnotatedSequence[] translate(Sequence[] s)
    {
        return translate(s, -1);
    }
    
    /**
     *
     * Read from a sequence with comments in the same form
     * as the Stanford Yeast database.
     *
     */
    public static AnnotatedSequence[] translate(Sequence[] s, int maxChars)
    {
        int n=s.length;
        AnnotatedSequence[] u=new AnnotatedSequence[n];
        for (int i=0; i<n; i++)
        {
            Sequence seq=s[i];
            if (maxChars!=-1)
                seq=seq.first(maxChars);
            
            String info=seq.getInfo();
            String id="id-missing";
            try
            {
                StringTokenizer t1=new StringTokenizer(info,":");
                t1.nextToken();
                StringTokenizer t=new StringTokenizer(t1.nextToken());
                id=t.nextToken();
            }
            catch (Exception e)
            {}
            String comments="comments not implemented";//info.substring(id.length()+1);
            u[i]=new AnnotatedSequence(seq, id, comments);
        }
        return u;
    }
    
}