package x.data.seq;

/**
  
  Utility class for creating random data for testing and
  experimental controls.
  
 */
public class RandomSequence
{
    public static Sequence make(int length, int low, int high)
    {
        byte[] b=new byte[length];
        for (int i=0; i<length; i++)
            b[i]=randomByte(low, high);
        return new Sequence(b);
    }
    public static Sequence[] makeArray(int count, int length, int low, int high)
    {
        Sequence[] s=new Sequence[count];
        for (int i=0; i<count; i++)
            s[i]=make(length, low, high);
        return s;
    }
    
    private static byte randomByte(int low, int high)
    {
        return (byte)(low+Math.random()*(high-low+1));
    }
}