package x.data.seq;

import java.io.*;
import java.util.*;

public class Sequence
{
    private byte[] dataArray;
    private String info="[no info]";
    
    public Sequence(int length)
    {
        this.dataArray=new byte[length];
    }
    
    public Sequence(byte[] dataArray)
    {
        this.dataArray=dataArray;
    }
    
    public Sequence(char[] data)
    {
        init(data);
    }
    
    private void init(char[] data)
    {
        int n=data.length;
        dataArray=new byte[n];
        DNA.bytesFor(data, dataArray);
    }

    public Sequence(String s)
    {
        int n=s.length();
        char[] c=new char[n];
        s.getChars(0,n,c,0);
        init(c);
    }
    
    public Sequence(StringBuffer b)
    {
        int n=b.length();
        char[] c=new char[n];
        b.getChars(0,n,c,0);
        init(c);
    }
    
    public Sequence first(int n)
    {
        int m=dataArray.length;
        int size=Math.min(m,n);
        byte[] c=new byte[size];
        System.arraycopy(dataArray,0,c,0,size);
        Sequence s= new Sequence(c);
        s.info=info;
        return s;
    }
    
    // order MN matching; if nec. replace w/ good algorithm later.
    public boolean match(Sequence other, int thisStartIndex, int otherStartIndex, int length)
    {
        if (dataArray.length<thisStartIndex+length)
            return false;
        byte[] d=other.data();
        for (int i=0; i<length; i++)
            if (d[i+otherStartIndex]!=dataArray[i+thisStartIndex])
                return false;
     
        return true;
    }
    
    // this is a dumb algorithm; if necessary to optimize
    // you could probably make it go a lot faster...
    public int countMatches(Sequence other, int otherStartIndex, int length)
    {
        int count=0;
        for (int i=0; i<dataArray.length; i++)
        {
            if (match(other, i, otherStartIndex, length))
                count++;
        }
        return count;
    }
    
    public void setInfo(String info)
    {
        this.info=info;
    }
    
    public String getInfo()
    {
        return info;
    }
    
    public int length()
    {
        return dataArray.length;
    }
    
    public void setData(byte[] dataArray)
    {
        this.dataArray=dataArray;
    }
    
    public void setData(int index, byte b)
    {
        dataArray[index]=b;
    }
    
    public byte data(int i)
    {
        return dataArray[i];
    }
    
    public byte[] data()
    {
        return dataArray;
    }
    
    public String toString()
    {
        int n=dataArray.length;
        char[] c=new char[n];
        for (int i=0; i<n; i++)
            c[i]=DNA.charFor(dataArray[i]);
        return new String(c);
    }
}
