package x.data.seq;

import java.util.*;
import java.io.*;

/**
 * 
 * Upstream transcription region, Stanford format.
 *
 */
public class UTR
{
    /**
     *
     * Read from a sequence with comments in the same form
     * as the Stanford Yeast database.
     *
     */
     
    public static AnnotatedSequence[] translate(Sequence[] s)
    {
        int n=s.length;
        AnnotatedSequence[] u=new AnnotatedSequence[n];
        for (int i=0; i<n; i++)
        {
            String info=s[i].getInfo();
            StringTokenizer t=new StringTokenizer(info);
            String id=t.nextToken();
            String comments=info.substring(id.length()+1);
            u[i]=new AnnotatedSequence(s[i], id, comments);
        }
        return u;
    }
    
}