package x.data.seq.test;

import x.data.*;
import x.path.*;
import x.awt.*;
import x.data.seq.*;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.zip.*;
import java.util.*;

public class AverageGraph extends Frame
{
    AverageSequence average;
    DataArray data;
    
    public static void main(String[] args)
    {
        try
        {
            //System.err.println("Expects sequences of 500 bp.");
            AverageGraph app=new AverageGraph();
            app.init(args[0]);
            app.setBounds(100,100,600,400);
            app.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {System.exit(0);}
            });
            app.setVisible(true);
        }
        catch (Exception e)
        {
            e.printStackTrace(System.err);
            System.err.println("Usage: AverageGraph seqfile");
        }
    }
    
    
    
    public void paint(Graphics g)
    {
        int w=getSize().width, h=getSize().height;
        byte c=DNA.A;
        float[] p=average.data(c);
        g.drawString("Percentage of "+DNA.stringFor(c)+" at each position", 50, 50);
        for (int i=0; i<p.length; i++)
        {
            int x=20+i;
            int y=(int)(350-400*p[i]);
            g.setColor(Color.lightGray);
            g.drawLine(x,y,x,57);
            g.setColor(Color.black);
            g.drawLine(x,350,x,y);
            if (i%100==0)
                g.drawString(i+""/*"-"+(500-i)*/, x, 365);
        }
        for (int z=0; z<=100; z+=10)
        {
            int x=525;
            int y=(int)(350-4*z);
            g.setColor(Color.black);
            g.drawString(z+"%",x,y);
        }
    }
    
    public void init(String seqFile) throws Exception
    {
        
        // Read UTR.
        Sequence[] seq=FASTA.readFromFile(seqFile);
        
        // Make averages.
        average=new AverageSequence();
        int good=0;
        for (int i=0; i<seq.length; i++)
        {
            if (seq[i].length()>=500)
            {
                average.add(seq[i].first(500));
                good++;
            }
        }
        System.err.println("Used "+good+" out of "+seq.length+" sequences.");
    }
    
    
    
}