package x.data.seq.test;

import x.data.*;
import x.path.*;
import x.awt.*;
import x.data.seq.*;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.zip.*;
import java.util.*;

public class SequenceScatter extends Frame
{
    AverageSequence average;
    DataArray data;
    PlotSeq[] p;
    
    
    public static void main(String[] args)
    {
        try
        {
            //System.err.println("Expects sequences of 500 bp.");
            SequenceScatter app=new SequenceScatter();
            app.init(args[0]);
            app.setBounds(100,100,800,800);
            app.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {System.exit(0);}
            });
            app.setVisible(true);
        }
        catch (Exception e)
        {
            e.printStackTrace(System.err);
            System.err.println("Usage: AverageGraph seqfile");
        }
    }
    
    
    
    public void paint(Graphics g)
    {
        int w=getSize().width, h=getSize().height;
        
        g.setColor(new Color(0,0,0,10));
        double scale=5;
        for (int i=0; i<p.length; i++)
        {
            //int x=(int)(scale*(w*p[i].x+Math.random()))%w;
            //int y=(int)(scale*(h*p[i].y+Math.random()))%h;
            int x=(int)(scale*w*p[i].x)%w;
            int y=(int)(scale*h*p[i].y)%h;
            //g.drawRect(x,y,1,1);
            g.fillRect(x,y,5,5);
        }
        
    }
    
    public void init(String seqFile) throws Exception
    {
        
        // Read UTR.
        Sequence[] seq=FASTA.readFromFile(seqFile);
        
        // Make averages.
        average=new AverageSequence();
        int n=seq.length;
        p=new PlotSeq[n];
        
        for (int i=0; i<n; i++)
        {
            p[i]=new PlotSeq(percent(DNA.A, seq[i]),
                             percent(DNA.C, seq[i]));
            
        }
    }
    
    double percent(byte q, Sequence s)
    {
        byte[] b=s.data();
        int n=b.length;
        if (n==0) return 0;
        double t=0;
        for (int i=0; i<n; i++)
            if (b[i]==q) t++;
        return t/n;
    }
    
    
    class PlotSeq
    {
        double x,y;
        PlotSeq(double x, double y)
        {
            this.x=x;
            this.y=y;
        }
    }
    
}