package x.data.set;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import x.awt.*;
import x.data.*;
import x.feature.*;

public class PlotSet extends Frame
{
    DataArray data;
    DataArrayIndex index;
    int[] outcome;
    GeneSet[] neighborhoods;
    GeneSet nbd;
    ColorScale colors=new GradientColorScale(
    	Color.blue, Color.white, Color.red, -1, 1
    );
    float[][] subset;
    int[] colOrder;
    static final int GOOD=0, BAD=1;
    int type=BAD;
    
    public static void main(String[] args)
    {
        try
        {
			PlotSet app=new PlotSet();
            app.setBounds(100,100,600,400);
            app.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {System.exit(0);}
            });
            app.init();
            app.setVisible(true);
        }
        catch (Exception e)
        {
            e.printStackTrace(System.err);
        }
    }
    
    void init() throws Exception
    {
		//neighborhoods=GeneSetFormat.read("c:\\data\\bio\\whitehead\\kenross\\shortset.mapped");
		neighborhoods=GeneSetFormat.read("c:\\data\\bio\\whitehead\\kenross\\"+
			"lung_kinase_corr.030626.35242_at.gene_list.mapped");
		outcome=OutcomeFormat.read("c:\\data\\bio\\whitehead\\kenross\\outcome.txt");
		data=new DataArray(
			"c:\\data\\bio\\whitehead\\kenross\\lungarray.meta", true);
		double min=Float.MAX_VALUE;
		double max=Float.MIN_VALUE;
		float[][] x=data.copyNumbers();
		//for (int i=0; i<x.length; i++)
		//{
			//for (int j=0; j<x[i].length; j++)
			//{
			//	min=Math.min(x[i][j], min);
			//	max=Math.max(x[i][j], max);
			//}
			//Stats.makeUnitSD(data.getRow(i).getNumbers());
			//Stats.makeUnitRange(data.getRow(i).getNumbers());
		//}
		System.out.println("min="+min);
		System.out.println("max="+max);
		index=new DataArrayIndex(data);
		
		nbd=neighborhoods[type];
		int setSize=nbd.set.size();
		int sampleNum=0;
		for (int i=0; i<outcome.length; i++)
			if (outcome[i]==0) sampleNum++;
		
		subset=new float[setSize][sampleNum];
		System.out.println("setSize="+setSize+", sampleNum="+sampleNum);
		Iterator it=nbd.set.iterator();
		int geneCount=0;
		while (it.hasNext())
		{
			DataRow row=index.row(it.next());
			int j=0;
			for (int i=0; i<outcome.length; i++)
				if (outcome[i]==type)
				{
					 subset[geneCount][j]=row.getNumbers()[i];
					 j++; 
				} 
			geneCount++;
		}
		if (geneCount!=setSize)
		{
			System.out.println("YIKES: geneCount="+geneCount+", yet setSize="+setSize);
		}
		for (int i=0; i<subset.length; i++)
		{
			Stats.makeUnitSD(subset[i]);
			Stats.makeUnitRange(subset[i]);
		}

		colOrder=sortColumns(subset);

    }
    
    
	public void paint(Graphics g)
	{
		int dx=30;
		int y=40;
		int s=2;
		Iterator i=nbd.set.iterator();
		int geneCount=0;
		while (i.hasNext())
		{
			i.next();
			y+=s+1;
			int x=dx;
			//System.out.println(i+" --> "+colOrder[i]);
			//DataRow row=index.row(i.next())
			//System.out.println("genecount="+geneCount);
			float[] vals=subset[geneCount];
			for (int j=0; j<vals.length; j++)
			{
				//System.out.print(j);
				//System.out.println(" --> "+colOrder[j]);
				g.setColor(colors.color(vals[colOrder[j]]));
				g.fillRect(x,y,s,s);
				x+=s+1;
			}
			//System.out.println(" ");
			geneCount++;
		}
	}
    
	public void oldpaint(Graphics g)
	{
		GeneSet gs=neighborhoods[0];
		int dx=30;
		int y=40;
		int s=10;
		Iterator i=gs.set.iterator();
		while (i.hasNext())
		{
			y+=s+1;
			int x=dx;
			DataRow row=index.row(i.next());
			float[] vals=row.getNumbers();
			for (int j=0; j<vals.length; j++)
			{
				if (outcome[j]==1) continue;
				//System.out.print(vals[j]+" ");
				g.setColor(colors.color(vals[j]));
				g.fillRect(x,y,s,s);
				x+=s+1;
			}
			//System.out.println(" ");
		}
	}
    
    int[] sortColumns(float[][] x)
    {    	
    	// find sums for each column.
    	int cols=x[0].length;
    	final float[] sum=new float[cols];
    	int rows=x.length;
    	for (int i=0; i<rows; i++)
    		for (int j=0; j<cols; j++)
    			sum[j]+=x[i][j];
    	
    	Integer[] colIndex=new Integer[cols];
    	for (int i=0; i<cols; i++)
    		colIndex[i]=new Integer(i);
    	/*
    	Arrays.sort(colIndex, new Comparator()
    	{
    		public int compare(Object a, Object b)
    		{
				int x=((Integer)a).intValue();
				int y=((Integer)b).intValue();
				if (sum[x]<sum[y])
					return -1;
				if (sum[y]<sum[x])
					return 1;
				return 0;
    		}
    	});
    	*/
    	int[] ci=new int[cols];
    	for (int i=0; i<cols; i++)
    		ci[i]=colIndex[i].intValue();
    	return ci;
    }
    
}