package x.feature;


public class Feature implements Comparable
{
	private Location location;
	private String id;
	private String type;
	
	public Feature(String id, String type, Location location)
	{
		this.id=id;
		this.type=type;
		this.location=location;
	}
	
	public int compareTo(Object o)
	{
		return location.compareTo(((Feature)o).location);
	}
	
	public String toString()
	{
		return "[Feature: id="+id+", types="+type+", loc="+location+"]";
	}
	
	public boolean isType(String type)
	{
		return this.type.indexOf(type)!=-1;
	}
	
	/**
	 * Returns the id.
	 * @return String
	 */
	public String getID()
	{
		return id;
	}

	/**
	 * Returns the location.
	 * @return Location
	 */
	public Location getLocation()
	{
		return location;
	}

	/**
	 * Sets the id.
	 * @param id The id to set
	 */
	public void setID(String id)
	{
		this.id = id;
	}

	/**
	 * Sets the location.
	 * @param location The location to set
	 */
	public void setLocation(Location location)
	{
		this.location = location;
	}

	/**
	 * Returns the type.
	 * @return String
	 */
	public String getType()
	{
		return type;
	}

	/**
	 * Sets the type.
	 * @param type The type to set
	 */
	public void setType(String type)
	{
		this.type = type;
	}

}
