package x.feature;

import java.awt.*;
import java.awt.event.*;

public class Heatmap extends Frame
{
	FeatureArray map;
	
	public static void main(String[] args)
	{
		try
		{
			Heatmap h=new Heatmap(new FeatureArray());
			h.launch();
		}
		catch (Exception e)
		{
			e.printStackTrace(System.err);
		}
	}
	
	public void launch()
	{
		setBounds(50,50,700,700);
		setVisible(true);
	}
	
	public void paint(Graphics g)
	{
		int dx=5, dy=30;
		int x=dx, y=dy;
		for (int i=0; i<map.measuredFeatures.length; i++)
		{
			MeasuredFeature m=map.measuredFeatures[i];
			draw(g, x, y, m.row.getNumbers());
			if (++y>getSize().height-5)
			{
				y=dy;
				x+=110;
			}
		}
	}
	
	void draw(Graphics g, int x, int y, float[] z)
	{
		for (int i=0; i<z.length; i++)
		{
			g.setColor(ArrayColors.valueScale.color(z[i]));
			g.drawLine(x+i,y,x+i,y);
		}
	}
	
	Heatmap(FeatureArray map)
	{
		this.map=map;
		setBackground(ArrayColors.bgcolor);
		setFont(new Font("Helvetica", Font.PLAIN, 9));
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {System.exit(0);}
		});
		
	}
}
