package x.feature;

import java.awt.*;
import java.awt.event.*;

public class PhysicalMap extends Frame
{	
	double[] r;
	FeatureArray map;
	
	public static void main(String[] args)
	{
		try
		{
			new PhysicalMap(new FeatureArray()).launch();
		}
		catch (Exception e)
		{
			e.printStackTrace(System.err);
		}
	}
	
	public void launch()
	{
		setBounds(50,50,700,700);
		setBackground(Color.gray);
		setVisible(true);
	}
	
	public void paint(Graphics g)
	{
		int dx=10;
		int max=map.getOverallChromosomeMax();
		int screenW=getSize().width-2*dx;
		MeasuredFeature[] m=map.measuredFeatures;
		g.setColor(Color.green);
		int q=40;
		
		int x=dx, y=100;
		for (int i=0; i<m.length-1; i++)
		{
			Location l0=m[i].feature.getLocation();
			Location l1=m[i+1].feature.getLocation();
			int d=l0.distance(l1);
			if (d==-1) continue;
			g.setColor(ArrayColors.correlationScale.color(r[i]));
			int dy=d/200;
			//System.out.println(l0.getStrand());
			if (l0.getStrand()!=l1.getStrand())
				dy=-dy;
			g.drawLine(x,y,x,y+dy);
			if (++x>screenW)
			{
				x=dx;
				y+=100;
			}
		}

		/*
		for (int i=0; i<m.length; i++)
		{
			Location l=m[i].feature.getLocation();
			int chr=l.getChromosome();
			int y=50+50*chr;
			int a=scale(l.getStart(), q*screenW, max);
			int b=scale(l.getStop(), q*screenW, max)-a;
			//System.out.println(l.getStart()+" ... "+a);
			int qx=a%screenW;
			int qy=2*(a/screenW);
			g.drawLine(dx+qx,y+qy,dx+qx+b,y+qy);
		}
		*/
	}
	
	int scale(double loc, double screenW, double chrMax)
	{
		return (int)((screenW*loc)/chrMax);
	}
	
	PhysicalMap(FeatureArray map)
	{	
		this.map=map;
		r=map.findR();
		setFont(new Font("Helvetica", Font.PLAIN, 9));
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {System.exit(0);}
		});		
	}
}
