package x.feature.early;

import x.data.*;
import x.feature.*;

import java.util.*;

public class CorrelationStats
{
	static String metaFile="c:\\data\\bio\\eisen-location.meta";
	static String featureFile="c:\\data\\bio\\yeast\\chromosomal_feature_tab.txt";
	
	
	DataArray profiles;
	
	public static void main(String[] args)
	{
		try
		{
			MeasuredFeature[] measuredFeatures;
			DataArray profiles=new DataArray(metaFile);
			System.out.println("profiles: "+profiles.size());
			
			Feature[] features=FeatureReader.readFile(featureFile, "ORF");
			System.out.println("features: "+features.length);

			HashMap indexMap=new HashMap();
			for (int i=0; i<profiles.size(); i++)
			{
				String id=profiles.getRow(i).getID();
				indexMap.put(id, new Integer(i));
			}
			
			ArrayList featureList=new ArrayList();		
			for (int i=0; i<features.length; i++)
			{
				Integer index=(Integer)indexMap.get(features[i].getID());
				if (index!=null)
					featureList.add(
						new MeasuredFeature(features[i],profiles.getRow(index.intValue())));
			}
			int n=featureList.size();
			measuredFeatures=new MeasuredFeature[n];
			for (int i=0; i<n; i++)
			{
				measuredFeatures[i]=(MeasuredFeature)featureList.get(i);
			}
			//shuffle(measuredFeatures);
			Arrays.sort(measuredFeatures);
			
			System.out.println("Matched ORFs: "+n);
			/*
			System.out.println("Normalizing all to unit sd.");
			int pn=profiles.size();
			for (int i=0; i<pn; i++)
				Stats.makeUnitSD(profiles.getRow(i).getNumbers());
			*/
			/*
			System.out.println("Normalizing all to unit range.");
			int pn=profiles.size();
			for (int i=0; i<pn; i++)
				Stats.makeUnitRange(profiles.getRow(i).getNumbers());
*/
			int cn=profiles.getRow(0).getNumbers().length;
			for (int j=0; j<cn; j++)
			{
				safeautocorrelation(profiles.getFields()[j+2].getName(), measuredFeatures, j);
			}
		}
		catch (Exception e)
		{
			e.printStackTrace(System.err);
		}
	}
	
	static void autocorrelation(String label, MeasuredFeature[] m, int col)
	{
		int n=m.length;
		double[] x0=new double[n-1];
		double[] x1=new double[n-1];
		
		for (int i=0; i<n-1; i++)
		{
			x0[i]=m[i].row.getNumbers()[col];
			x1[i]=m[i+1].row.getNumbers()[col];
			//if (col==0)
			//	System.out.println(x0[i]);
		}
		System.out.println(label+"\t"+Stats.r(x0,x1)+"\t");
	}
	
	static void safeautocorrelation(String label, MeasuredFeature[] m, int col)
	{
		int n=m.length;
		double[] x0=new double[n-1];
		//double[] x1=new double[n-1];
		
		for (int i=0; i<n-1; i++)
		{
			x0[i]=m[i].row.getNumbers()[col];
			//x1[i]=m[i+1].row.getNumbers()[col];
			//if (col==0)
			//	System.out.println(x0[i]);
		}
		double[] x=Stats.safe(x0);
		if (x.length==0)
		{
			System.out.println("(blank data)");
			return;
		}
		System.out.println(label+"\t"+Stats.autoCorr(x)+"\t");
		//System.out.println(label+"\t"+Stats.r(x0,x1)+"\t");
	}
	
	static void shuffle(Object[] o)
	{
		int n=o.length;
		for (int i=0; i<n; i++)
		{
			int j=(int)(n*Math.random());
			Object p=o[i];
			Object q=o[j];
			o[i]=q;
			o[j]=p;
		}
	}
}
