package x.label;

import x.awt.*;
import java.awt.*;

/**
 
 size: size of label.
 target: location of target:
 bounds: screen bounds to keep label within.
 
 */
public class BlockLabel
{
    public static Point placement(Dimension size,
                                      int targetX, int targetY, int targetW, int targetH,
                                      int boundsX, int boundsY, int boundsW, int boundsH)
    {
        int pad=10;
        int w=size.width, h=size.height;
        Point p=new Point(targetX+targetW+pad, targetY+pad);
        if (p.x+w>boundsX+boundsW)
        {
            p.x=targetX-w-pad;
        }
        if (p.y+h>boundsH)
        {
            p.y=boundsH-h;
        }
        return p;
    }
    
    public static Point placement(int w, int h,
                                      Rectangle target,
                                      int boundsX, int boundsY, int boundsW, int boundsH)
    {
        return placement(new Dimension(w,h), target.x, target.y, target.width, target.height,
            boundsX, boundsY, boundsW, boundsH);
    }
    
    public static void simpleLabel(Graphics g, String[] label, Font font,
                                      Rectangle target,
                                      int boundsX, int boundsY, int boundsW, int boundsH)
    {
        FontMetrics fm=g.getFontMetrics(font);
        g.setFont(font);
        int lw=0;
        int i;
        for (i=0; i<label.length; i++)
            lw=Math.max(lw, fm.stringWidth(label[i]));
        lw+=10;
        int lineHeight=fm.getHeight();
        g.setColor(Color.white);
        int lh=label.length*lineHeight+6;
        Point p=placement(lw,lh, target, boundsX, boundsY, boundsW, boundsH);
        g.fillRect(p.x,p.y,lw,lh);
        g.setColor(Color.black);
        for (i=0; i<label.length; i++)
            g.drawString(label[i],p.x+7,3+p.y+lineHeight*i+fm.getAscent());
        g.drawRect(p.x,p.y,lw,lh);
    }
}