package x.label;

import x.util.*;

import java.awt.*;
import java.util.*;

public class LabelRect extends Rectangle implements Ordering
{
    private String label;
    private Rectangle target;
    
    public LabelRect()
    {
        super(0,0,0,0);
    }
    
    public LabelRect(String label, Rectangle target, int x, int y, int w, int h)
    {
        super(x,y,w,h);
        this.label=label;
        this.target=target;//new Rectangle(target.x, target.y, 1+target.width, 1+target.height);
    }
    
    public int order(Object x, Object y)
    {
        Rectangle r1=((LabelRect)x).getTarget();
        Rectangle r2=((LabelRect)y).getTarget();
        
        //double a=r1.width*r1.height-r2.width*r2.height;
        double a=r1.height-r2.height;
        if (a>0) return -1;
        if (a<0) return 1;
        return 0;
    }
    
    // v is a Vector of LabelRects; 
    // bounds is the bounding rect they all must fit into.
    public static void placeNicely(Vector v, int w, int h)
    {
        // put into an array.
        int n=v.size();
        LabelRect[] r=new LabelRect[n];
        v.copyInto(r);
        Sort10.sort(new LabelRect(),r);
        
        int unit=10;
        int uw=w/unit+1;
        int uh=h/unit+1;
        int[][] field=new int[uw][uh];
        int i;
        for (i=0; i<n; i++)
        {
            r[i].y=unit*(1+r[i].y/unit);
            //r[i].x=unit*(1+r[i].x/unit);
            int dt=1;
            while (collides(r[i], field, uw, uh, unit))
            {
                r[i].y+=unit;
                /*
                r[i].y+=dt*unit;
                if (dt>0)
                    dt=-dt-1;
                else
                    dt=-dt+1;
                    */
            }
            add(r[i], field, uw, uh, unit, 1);
        }
        
        
    }
    
    static void add(LabelRect r, int[][] field, int uw, int uh, int unit, int factor)
    {
        int y=r.y/unit;
        int x=r.x/unit;
        int w=1+r.width/unit;
        for (int i=0; i<w; i++)
            if (y>=0 && y<uh && x+i>=0 && x+i<uw)
                field[x+i][y]+=factor;
    }
    
    static boolean collides(LabelRect r, int[][] field, int uw, int uh, int unit)
    {
        int y=r.y/unit;
        int x=r.x/unit;
        int w=1+r.width/unit;
        for (int i=0; i<w; i++)
            if (y>=0 && y<uh && x+i>=0 && x+i<uw && field[x+i][y]>0)
                return true;
        return false;
    }
    
    public Rectangle getTarget()
    {
        return target;
    }
    
    public String getLabel()
    {
        return label;
    }
}