package x.label.test;

import x.label.*;
import x.awt.*;
import java.awt.*;
import java.awt.event.*;

public class TestBlockLabel extends Frame
{
    Drawing drawing;
    
    public static void main(String[] args)
    {
        try
        {
            TestBlockLabel app=new TestBlockLabel();
            app.setBounds(100,100,600,400);
            app.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {System.exit(0);}
            });
            app.init();
            app.setVisible(true);
        }
        catch (Exception e)
        {
            e.printStackTrace(System.err);
        }
    }
    
    void init()
    {
        setLayout(new GridLayout(1,1));
        drawing=new TestDrawing();
        add(new TestPanel());
    }
    
    class TestDrawing implements Drawing
    {
        int w=50,h=50;
        
        public Dimension getSize()
        {
            return new Dimension(w,h);
        }
        
        public void draw(Graphics g, int x, int y)
        {
            g.setColor(Color.white);
            g.fillRect(x,y,w,h);
            g.setColor(Color.black);
            g.drawRect(x,y,w,h);
            g.drawString("Testing!",x+5,y+30);
        }
    }
    
    class TestPanel extends BufferPanel 
    {
        int x,y;
        
        TestPanel()
        {
            addMouseMotionListener(new MouseMotionAdapter()
            {
                public void mouseMoved(MouseEvent m)
                {
                    x=m.getX(); y=m.getY(); redraw();
                }
            });
        }
        
        public void drawOffscreen(Graphics g)
        {
            clearBuffer();
           
            if (drawing==null) 
            {
                g.drawString("Null drawing", 30,30);
                return;
            }
            int a=10*(x/10), b=10*(y/10);
            Point p=BlockLabel.placement(drawing.getSize(),
                a,b,10,10, 
                0,0,getSize().width,getSize().height);
            drawing.draw(g, p.x, p.y);
            g.setColor(Color.gray);
            g.fillRect(a,b,10,10);
        }
    }
}
