package x.math;

public class Permutation
{
    public static int[] invert(int[] order)
    {
        int n=order.length;
        int[] inverse=new int[n];
        for (int i=0; i<n; i++)
            inverse[order[i]]=i;
        return inverse;
    }
    
    public static int[] compose(int[] order1, int[] order2)
    {
        int n=order1.length;
        if (n!=order2.length)
            throw new IllegalArgumentException("permutations not same length: "+
                n+" != "+order2.length);
        int[] result=new int[n];
        for (int i=0; i<n; i++)
            result[i]=order1[order2[i]];
        return result;
    }
    
    public static int[] id(int n)
    {
        int[] order=new int[n];
        for (int i=0; i<n; i++)
            order[i]=i;
        return order;
    }
    
    public static boolean equal(int[] order1, int[] order2)
    {
        int n=order1.length;
        if (n!=order2.length)
            return false;
        for (int i=0; i<n; i++)
            if (order1[i]!=order2[i]) return false;
        return true;
    }
    
    public static String makeString(int[] order)
    {
        StringBuffer b=new StringBuffer("{ ");
        for (int i=0; i<order.length; i++)
            b.append(order[i]+" ");
        b.append("}");
        return b.toString();
    }
}