package x.message.progress;

public class Heartbeat extends Thread
{
    private ProgressListener progressListener;
    private ProgressMessage message;
    private long delay;
    private boolean alive=true;
    
    public Heartbeat(ProgressListener progressListener, ProgressMessage message, int delay)
    {
        this.progressListener=progressListener;
        this.message=message;
        this.delay=delay;
        setPriority(MAX_PRIORITY);
    }
    
    public void end()
    {
        alive=false;
    }
    
    public void run()
    {
        while (alive)
        {
            progressListener.reportProgress(message);
            try {Thread.sleep(delay);} catch (InterruptedException e) {}
        }
          
    }
}