package x.path;

import x.path.*;
import java.awt.*;
import java.awt.event.*;

public class PathTest extends x.awt.FrameApp
{
    PathLayout path;
    static int by=20;
    
    PathTest(int length, int width, int height)
    {
        path=new HilbertPath(length, width, height);
    }
    
    public void paint(Graphics g)
    {
        // Draw grid.
        g.setColor(Color.lightGray);
        int pw=path.getSize().width, ph=path.getSize().height;
        int w=getSize().width, h=getSize().height-by;
        for (int x=0; x<=pw; x++)
        {
            int a=(x*w)/pw;
            g.drawLine(a,by,a,h);
        }
        for (int y=0; y<=ph; y++)
        {
            int b=(y*h)/ph+by;
            g.drawLine(0,b,w,b);
        }
        
        // draw path.
        g.setColor(Color.black);
        Point old=null;
        for (int i=0; i<path.getLength(); i++)
        {
            
            int a=(int)(((path.x(i)+.5)*w)/pw);
            int b=(int)(((path.y(i)+.5)*h)/ph+by);
            g.fillRect(a-2,b-2,5,5);
            if (old!=null)
                g.drawLine(a,b,old.x, old.y);
            old=new Point(a,b);
        }
    }
    
    public static void main(String[] args)
    {
        try
        {
            PathTest p=new PathTest(
                Integer.parseInt(args[0]),
                Integer.parseInt(args[1]),
                Integer.parseInt(args[2])
            );
            p.launch(100,100,400,400+2*by);
        }
        catch (Exception e)
        {
            e.printStackTrace(System.err);
            System.err.println("Usage: PathTest length width height");
        }
    }
}