package x.path;

import java.awt.*;

public class ReadingPath implements PathLayout
{
    private int width;
    private int height;
    private int length;
    
    public ReadingPath(int length, int w, int h)
    {
        setMaxBounds(length,w,h);
    }
    
    public int order(int x, int y)
    {
        return y*width+x;
    }
    
    public boolean contains(int x, int y)
    {
        int n=order(x,y);
        return n>=0 && n<length;
    }
    
    public int x(int n)
    {
        return n%width;
    }
    
    public int y(int n)
    {
        return n/width;
    }
    
    public Point getPoint(int n)
    {
        return new Point(n%width, n/width);
    }
    
    public Dimension getSize()
    {
        return new Dimension(width, height);
    }
    
    public int getLength()
    {
        return length;
    }
    
    public void setMaxBounds(int length, int width, int height)
    {
        this.length=length;
        this.width=width;
        this.height=height;
    }
}