package x.path.test;

import x.path.*;
import java.awt.*;

public class HCurveTest extends Frame
{
    int w,h;
    PathLayout path;
    static int dh=20;
    
    HCurveTest(int w, int h)
    {
        this.w=w;
        this.h=h;
        setBackground(Color.black);
        
    }
    
    public static void main(String args[]) 
    {
        System.out.println("using args[0]=length");
        int n=Integer.parseInt(args[0]);

        PathLayout path=new HCurve(n);
        int m=(int)Math.ceil(Math.sqrt(n));
        //PathLayout path=new OxplowPath(n,m,m);
        Dimension d=path.getSize();
        HCurveTest test=new HCurveTest(d.width, d.height);
        test.path = path;
        test.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent e) {System.exit(0);}
        });
        test.setBounds(100,100,200,200+dh);
        test.setVisible(true);
    }
    
    public void paint(Graphics g) 
    {
        Rectangle rr = getBounds();
        int xa = 0;
        int ya = 0;
        int x = 0;
        int y = 0;
        int xn, yn, ww;
        PathLayout r;
        int n=h;
        if (n > 256) {n = 256;}
        if (w > 256) {w = 256;}
        if (n > w) {ww = n;} else {ww=w;}
        r = path;
        int f=Math.min((rr.width-6)/(w-1), (rr.height-6)/(h-1));
        int off=4;
        if (f*w > rr.width) {f = rr.width/w;}
        if (f*n > rr.height) {f = rr.height/n;}
        if (f==0) f=1;

        g.setColor(new Color(0x003399));
        System.out.println("path.getLength()="+path.getLength());
        for (int i = 0; i < path.getLength(); i++) 
        {
           if (i==300)
                g.setColor(new Color(0x66cc66));
           if (i==330)
                g.setColor(new Color(0xffffff));
           x = r.x(i); y = r.y(i);
           thick(g,2,xa*f+off,(n-1-ya)*f+off+dh,x*f+off,(n-1-y)*f+off+dh);
           //g.fillRect(xa*f+off,(n-1-ya)*f+off+dh,f,f);
           xa = x; ya = y;
        }
    }
    
    void thick(Graphics g, int t, int x1, int y1, int x2, int y2)
    {
        for (int i=0; i<t; i++)
            for (int j=0; j<t; j++)
                g.drawLine(x1+i,y1+j,x2+i,y2+j);
        
    }
    
}