package x.util;

/**
 *
 * A Java 1.0-compatible sorting routine.
 *
 */
public class Sort10
{
    public static void sort(Ordering c, Object[] array)
    {
        sort(c,array,0,array.length-1);
    }
    
    public static void sort(Ordering c, Object[] array, int start, int end)
    {
        int p;
        if (end > start)
        {
            p = divide(c, array, start, end);
            sort(c, array, start, p-1);
            sort(c, array, p+1, end);
        }
    }

    private static int divide(Ordering c, Object[] array, int start, int end)
    {
        
        int left, right;
        Object p = array[end];

        left = start - 1;
        right = end;
        Object t;
        for (;;)
        {
            while (c.order(p, array[++left])<0 && left!=end);
            while (c.order(p,array[--right])>0 && right!=start);
            if (left >= right) break;
            t=array[left];
            array[left]=array[right];
            array[right]=t;
        }
        t=array[left];
        array[left]=array[end];
        array[end]=t;
        

        return left;
    }
}
 

