package x.viz.biplot.test;

import x.viz.biplot.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class BiplotTest extends Frame
{
    static int startW=500, startH=300;
    DensityBiplotViewer screen;
    
    public static void main(String[] args)
    {
        
        try
        {
            BiplotTest c=new BiplotTest();
            c.launch(100,100,startW,startH);
            c.screen.start();
        }
        catch (Exception e)
        {
            e.printStackTrace(System.err);
        }
    }
    
    public void launch(int x, int y, int w, int h)
    {
        setBounds(x,y,w,h);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) 
            {
                screen.stop();
                System.exit(0);
            }
        });
        setVisible(true);
    }
    
    
    private BiplotTest()
    {
        super("Density Biplot Test");
        
        double[] xd=fake(1000);
        double[] yd=fake(1000);
        PlotPoint[] points=fakePoints(1000,1000);
        
        // Create and add plotting component.
        screen=new DensityBiplotViewer(new BiplotModel(xd, yd, points));
        setLayout(new GridLayout(1,1));
        add(screen);
    }
    
    PlotPoint[] fakePoints(int n, int max)
    {
        PlotPoint[] p=new PlotPoint[n];
        for (int i=0; i<n; i++)
        {
            p[i]=new PlotPoint((int)(max*Math.random()), 
                               (int)(max*Math.random()));
        }
        return p;
    }
    
    double[] fake(int n)
    {
        double[] x=new double[n];
        double p=n*Math.random();
        for (int i=0; i<n; i++)
        {
            double s=Math.sin(20*(i+p)/(double)n);
            x[i]=.3*Math.random()+s*s;
        }
        return x;
    }
    
}