package x.viz.biplot.test;

import x.viz.biplot.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class TestGap extends Frame
{
    static int startW=500, startH=300;
    DensityBiplotViewer screen;
    
    public static void main(String[] args)
    {
        
        try
        {
            TestGap c=new TestGap();
            c.launch(100,100,startW,startH);
            c.screen.start();
        }
        catch (Exception e)
        {
            e.printStackTrace(System.err);
        }
    }
    
    public void launch(int x, int y, int w, int h)
    {
        setBounds(x,y,w,h);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) 
            {
                screen.stop();
                System.exit(0);
            }
        });
        setVisible(true);
    }
    
    
    private TestGap()
    {
        super("Density TestGap Test");
        
        double[] xd=fake(1000);
        double[] yd=fake(1000);
        PlotPoint[] points=fakePoints(1000,1000);
        
        // Create and add plotting component.
        BiplotModel m=new BiplotModel(xd, yd, points);
        
        //Gap[] g1={ new Gap(500,50) };
        //Gap[] g2={ new Gap(100,100), new Gap(300,20)};
        Vector g1=new Vector();
        g1.addElement(new Gap(500,50));
        Vector g2=new Vector();
        g2.addElement(new Gap(100,100));
        g2.addElement(new Gap(300,20));
        
        BiplotModel gm=Gap.addGaps(m, g1, g2);
        screen=new DensityBiplotViewer(gm);
        setLayout(new GridLayout(1,1));
        add(screen);
    }
    
    PlotPoint[] fakePoints(int n, int max)
    {
        PlotPoint[] p=new PlotPoint[n];
        for (int i=0; i<n; i++)
        {
            p[i]=new PlotPoint((int)(max*Math.random()), 
                               (int)(max*Math.random()));
        }
        return p;
    }
    
    double[] fake(int n)
    {
        double[] x=new double[n];
        double p=n*Math.random();
        for (int i=0; i<n; i++)
        {
            double s=Math.sin(20*(i+p)/(double)n);
            x[i]=.3*Math.random()+s*s;
        }
        return x;
    }
    
}