package x.viz.seq;

import x.awt.*;
import java.awt.*;

public class ByteColorScale implements ColorScale
{
    DiscreteColorScale d;
    
    public ByteColorScale(ColorScale base, double low, double high)
    {
        d=new DiscreteColorScale(256, Color.gray);
        int i;
        double mid=(low+high)/2;
        double len=high-mid;
        for (i=0; i<256; i++)
        {
            double x=(double)(byte)i;
            double y=mid+(x*len)/127;
            //System.out.println(x+" --> "+y);
            d.setColor(i, base.color(y));
        }
    }
    
    public Color color(double x)
    {
        if (x<0) x+=256;
        return d.color(x);
    }
}