package x.viz.seq;

import x.data.seq.*;
import x.data.*;
import x.awt.*;
import java.awt.*;

public class SequenceDetailViewer extends BufferPanel
{
    AnnotatedSequence[] u;
    DataArray data;
    int startX=0, startY;
    Color letterColor=new Color(128,160,220);
    Color mainLetterColor=new Color(0,51,153);
    Color annotationColor=Color.lightGray;
    SequenceListModel model;
    Font letterFont=new Font("Helvetica", Font.PLAIN, 10);

    
    public SequenceDetailViewer(SequenceListModel model, DataArray data, AnnotatedSequence[] u)
    {
        this.model=model;
        this.data=data;
        this.u=u;
        for (int i=0; i<u.length; i++)
        {
            if (u[i]==null)
                System.out.println("null seq at "+i);
        }
    }
    
    public void setModel(SequenceListModel model)
    {
        this.model=model;
        redraw();
    }
    
    public void setStart(int startX, int startY)
    {
        this.startX=startX;
        this.startY=startY;
        redraw();
    }
    
    public void drawOffscreen(Graphics g)
    {
        clearBuffer();
        g.setColor(letterColor);
        int y=15;
        int i=startY;
        
        int len=50;
        //System.out.println("startX="+startX);
        //StringBuffer b=new StringBuffer(len);
        ColorScale scale=model.getColorScale();
        g.setFont(letterFont);
        while (y<getSize().height && i<u.length)
        {
            if (i>=0 && y>-20)
            {
                int x=5;
                
                AnnotatedSequence seq=u[i];
                byte[] c=seq.getSequence().data();
                int index=seq.getDataIndex();
                DataRow row=data.getRow(index);
                Sequence value=model.getSequences()[i];
                int limit=Math.max(value.length(), c.length);
                try
                {
                    for (int j=Math.max(0,startX); x<200 && j<limit; j++)
                    {
                        //g.setColor(c[j]==DNA.A ? mainLetterColor : letterColor);
                        g.setColor(scale.color(value.data(j)));
                        g.drawString(DNA.stringFor(c[j]),x,y);
                        x+=10;
                    }
                }
                 catch (Exception e) {} // array index prob???
                 //g.setColor(annotationColor);
                 g.setColor(model.getExpressionColor().color(model.getValues()[i]));
                 g.drawString(model.formattedValue(i),x+30,y);
                 g.setColor(annotationColor);
                 g.drawString(index+": "+row.getText()[1], x+70,y);
                 //g.drawString(model.formattedValue(i)+": "+index+": "+row.getText()[1], x+10,y);
            }
            y+=14;
            i++;
        }
    }
}
