package x.viz.seq;

import x.data.seq.*;
import x.awt.*;

import java.awt.Color;
import java.text.*;

public class SequenceListModel
{
    private int size;
    private Sequence[] seq;
    private ColorScale scale;
    private double[] values;
    private DecimalFormat num=new DecimalFormat("0.00");
    private ColorScale expressionColor=new GradientColorScale(Color.red, Color.gray, 
            Color.green, -2,2);
    
    public SequenceListModel(Sequence[] seq, double[] values, ColorScale scale)
    {
        this.seq=seq;
        this.scale=scale;
        this.values=values;
    }
    
    public String formattedValue(int i)
    {
        return num.format(values[i]);
    }
    
    public ColorScale getExpressionColor()
    {
    	return expressionColor;
    }
    
    public ColorScale getColorScale()
    {
        return scale;
    }
    
    public double[] getValues()
    {
        return values;
    }
    
    public int size()
    {
        return seq.length;
    }
    
    public Sequence[] getSequences()
    {
        return seq;
    }
}