package x.viz.seq.test;

import x.viz.seq.*;
import x.data.seq.*;
import x.awt.*;
import java.awt.*;
import java.awt.event.*;

public class TestSequenceView extends Frame
{
        
    public static void main(String[] args)
    {
        try
        {
            TestSequenceView c=new TestSequenceView();
            c.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {System.exit(0);}
            });
            c.setBounds(50,50,500,500);
            
            c.init();
        }
        catch (Exception e)
        {
            e.printStackTrace(System.err);
        }
    }
    
    public void init()
    {
        //DiscreteColorScale d=new DiscreteColorScale(256, Color.red);
        //for (int i=0; i<256; i++)
        //    d.setColor(i,new Color(i,i,i));
        ColorScale d=new GradientColorScale(Color.red, Color.black, 
                                                Color.green, -.5, .5);
        ByteColorScale bc=new ByteColorScale(d, -.5, .5);
        Sequence[] seq=new Sequence[1000];
        double[] values=new double[seq.length];
        for (int i=0; i<seq.length; i++)
        {
            seq[i]=RandomSequence.make(600,0,255);
            values[i]=Math.random();
        }
        
        SequenceListModel model=new SequenceListModel(seq, values, bc);
        SequenceListViewer v=new SequenceListViewer(model);
        setLayout(new GridLayout(1,1));
        add(v);
        v.redraw();
        setVisible(true);
    }
    
    public Dimension getPreferredSize()
    {
        return new Dimension(500,500);
    }
    
    public TestSequenceView()
    {
        super("TestSequenceView");
    }
}