package x.data.seq;

public class DNA
{
    public static final byte A=0;
    public static final byte T=1;
    public static final byte C=2;
    public static final byte G=3;
    
    private static char[] nucleotide={'A', 'T', 'C', 'G'};
    private static String[] nucleotideStrings={"A", "T", "C", "G"};
    
    public static final byte complement(byte b)
    {
        return (byte)(3-b);
    }
    
    public static final char charFor(byte b)
    {
        return nucleotide[b];
    }
    
    public static final String stringFor(byte b)
    {
        return nucleotideStrings[b];
    }
    
    public static final void bytesFor(char[] c, byte[] b)
    {
        for (int i=c.length-1; i>=0; i--)
            b[i]=byteFor(c[i]);
    }
    
    public static final byte byteFor(char c)
    {
        switch (c)
        {
            case 'A':
            case 'a': return DNA.A;
            case 'C':
            case 'c': return DNA.C;
            case 'T':
            case 't': return DNA.T;
            case 'G':
            case 'g': return DNA.G;
            default: throw new IllegalArgumentException("Unknown nucleotide: "+c);
        }
    }
}