package x.data.seq;

import java.util.*;
import java.io.*;

/**
 *
 * Reads an array of Sequence objects that are
 * encoded in FASTA format.
 *
 */
public class FASTA
{

    public static Sequence[] readFromFile(String fileName) throws IOException
    {
        FileReader r=new FileReader(fileName);
        BufferedReader in=new BufferedReader(r);
        Sequence[] u=null;
        try
        {
            u=read(in);
        }
        finally
        {
            in.close();
            r.close();
        }
        return u;
    }
    
    public static Sequence[] read(BufferedReader in) throws IOException
    {
        Vector v=new Vector();
        StringBuffer b=new StringBuffer();
        String info=null;
        String id=null;
        String line=null;
        while (null!=(line=in.readLine()))
        {
            if (line.startsWith(">"))
            {
                if (info!=null)
                {
                    Sequence s=new Sequence(b);
                    s.setInfo(info);
                    v.addElement(s);
                }
                b=new StringBuffer();
                info=line.substring(1);
            }
            else
                b.append(line);
        }
        if (info!=null)
        {
            Sequence s=new Sequence(b);
            s.setInfo(info);
            v.addElement(s);
        }
        int n=v.size();
        Sequence[] u=new Sequence[n];
        v.copyInto(u);
        return u;
    }
}